## org.apache.lucene.search.spans
Class SpanNotQuery

    java.lang.Object
      org.apache.lucene.search.Query
          org.apache.lucene.search.spans.SpanQuery
              org.apache.lucene.search.spans.SpanNotQuery

All Implemented Interfaces:
  Cloneable

    public class SpanNotQuery

extends SpanQuery
implements Cloneable

Removes matches which overlap with another SpanQuery.

Constructor Summary
`SpanNotQuery(SpanQuery include, SpanQuery exclude)` Construct a SpanNotQuery matching spans from `include` which have no overlap with spans from `exclude`.

Method Summary
`SpanNotQuery` `clone()` Returns a clone of this query.
`boolean` `equals(Object o)` Returns true iff `o` is equal to this.
`void` `extractTerms(Set<Term> terms)` Expert: adds all terms occurring in this query to the terms set.
`SpanQuery` `getExclude()` Return the SpanQuery whose matches must not overlap those returned.
`String` `getField()` Returns the name of the field matched by this query.
`SpanQuery` `getInclude()` Return the SpanQuery whose matches are filtered.
`Spans` `getSpans(AtomicReaderContext context, Bits acceptDocs, Map<Term,TermContext> termContexts)` Expert: Returns the matches for this query in an index.
`int` `hashCode()`
`Query` `rewrite(IndexReader reader)` Expert: called to re-write queries into primitive queries.
`String` `toString(String field)` Prints a query to a string, with `field` assumed to be the default field and omitted.

Methods inherited from class org.apache.lucene.search.spans.SpanQuery
`createWeight`

Methods inherited from class org.apache.lucene.search.Query
`getBoost, setBoost, toString`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### SpanNotQuery

    public SpanNotQuery(SpanQuery include,
                        SpanQuery exclude)

  Construct a SpanNotQuery matching spans from `include` which have no overlap with spans from `exclude`.

Method Detail

### getInclude

    public SpanQuery getInclude()

  Return the SpanQuery whose matches are filtered.

### getExclude

    public SpanQuery getExclude()

  Return the SpanQuery whose matches must not overlap those returned.

### getField

    public String getField()

  Description copied from class: `SpanQuery`
  Returns the name of the field matched by this query.

  Specified by:
    `getField` in class `SpanQuery`

### extractTerms

    public void extractTerms(Set<Term> terms)

  Description copied from class: `Query`
  Expert: adds all terms occurring in this query to the terms set. Only works if this query is in its `rewritten` form.

  Overrides:
    `extractTerms` in class `Query`

### toString

    public String toString(String field)

  Description copied from class: `Query`
  Prints a query to a string, with `field` assumed to be the default field and omitted.

  Specified by:
    `toString` in class `Query`

### clone

    public SpanNotQuery clone()

  Description copied from class: `Query`
  Returns a clone of this query.

  Overrides:
    `clone` in class `Query`

### getSpans

    public Spans getSpans(AtomicReaderContext context,
                          Bits acceptDocs,
                          Map<Term,TermContext> termContexts)
                   throws IOException

  Description copied from class: `SpanQuery`
  Expert: Returns the matches for this query in an index. Used internally to search for spans.

  Specified by:
    `getSpans` in class `SpanQuery`
  Throws:
    `IOException`

### rewrite

    public Query rewrite(IndexReader reader)
                  throws IOException

  Description copied from class: `Query`
  Expert: called to re-write queries into primitive queries. For example, a PrefixQuery will be rewritten into a BooleanQuery that consists of TermQuerys.

  Overrides:
    `rewrite` in class `Query`
  Throws:
    `IOException`

### equals

    public boolean equals(Object o)

  Returns true iff `o` is equal to this.

  Overrides:
    `equals` in class `Query`

### hashCode

    public int hashCode()

  Overrides:
    `hashCode` in class `Query`

Copyright © 2000-2013 Apache Software Foundation. All Rights Reserved.